PROCEDURE DoAscii;

VAR
TempB, J : BYTE;
Analyzed : BOOLEAN;

FUNCTION GetCodePage: WORD; ASSEMBLER;

ASM
MOV AX, 6601h
INT 21h
MOV AX, BX
END;

FUNCTION GetStartPage: WORD; ASSEMBLER;

ASM
MOV AX, 6601h
INT 21h
MOV AX, DX
END;

FUNCTION GetCountry:BYTE;

VAR
S, O    : WORD;
Return  : BYTE;

BEGIN
S := Seg(Country);
O := Ofs(GetCountry);
ASM
MOV AH, 38h
MOV BX, S
MOV DS, BX
MOV DX, O
XOR AL, AL
INT 21H
MOV Return, BL
END;
GetCountry := Return;
END;

PROCEDURE UpDateView;

VAR
I, J, Counter : BYTE;

BEGIN
Counter := 0;
FOR I := 8 TO 23 DO
FOR J := 11 TO 41 DO
BEGIN
VRAM[I, J] := ((((LightCyan SHL 4)+Black)-128) SHL 8) OR Counter;
IF Counter = CurMarked THEN
VRAM[I, J] := (((Blue SHL 4)+Yellow) SHL 8) OR Counter;
Inc(Counter);
Inc(J);
IF J = 42 THEN
BREAK;
END;
END;

PROCEDURE AnalyzeFile;

VAR
TempL, OldPos : LONGINT;
Mode : BYTE;

BEGIN
GotoXY(46, 12);
TextBackGround(LightCyan);
TextColor(Black);
Write('Analyzing File...   ');
OldPos := FilePos(WorkFile);
Seek(WorkFile, 0);
FillChar(Frequenzy, SizeOf(Frequenzy), 0);
WHILE NOT EoF(WorkFile) DO
BEGIN
BlockRead(WorkFile, TempB, SizeOf(TempB));
Inc(Frequenzy[TempB]);
END;
Seek(WorkFile, OldPos);
TempL := Frequenzy[0];
J := 0;
FOR I := 1 TO 255 DO
IF Frequenzy[I] > TempL THEN
BEGIN
TempL := Frequenzy[I];
J := I
END;
GotoXY(61, 14);
Write(J);
TempL := Frequenzy[0];
J := 0;
Mode := 0;
FOR I := 1 TO 255 DO
BEGIN
IF Frequenzy[I] < TempL THEN
BEGIN
TempL := Frequenzy[I];
J := I
END
ELSE
IF Frequenzy[I] = TempL THEN
Inc(Mode);
END;
GotoXY(57, 16);
IF Mode < 10 THEN
Write(J)
ELSE
Write('-');
GotoXY(46, 12);
Write('File Analyzed...   ');
Analyzed := TRUE;
END;

BEGIN
SaveScreen;
HideCursor;
FoldOffWindow(' ASCII - Info ', 9, 6, 71, 25, LightCyan, Yellow, 1);
FOR I := 7 TO 24 DO
VRAM[I, 44] := ((((LightCyan SHL 4)+Blue)-128) SHL 8) OR 73;
GotoXY(46, 8);
TextBackGround(LightCyan);
TextColor(DarkGray);
Write('Country-Code      : ');
GotoXY(46, 9);
Write('Codepage - Current: ');
GotoXY(46, 10);
Write('Codepage - Start  : ');
GotoXY(66, 8);
TextColor(Black);
Write(GetCountry);
GotoXY(66, 9);
Write(GetCodePage);
GotoXY(66, 10);
Write(GetStartPage);
GotoXY(46, 12);
Write('File Not Analyzed...');
TextColor(DarkGray);
GotoXY(46, 14);
Write('Most frequent: ?');
GotoXY(46, 16);
Write('Most rare: ?');
GotoXY(46, 19);
Write('Current: ?');
GotoXY(46, 21);
Write('ASCII-Code: ');
InfoBar(ASCII);
StatusBar('WAITING...');
Analyzed := FALSE;
CurMarked := 0;
REPEAT
UpDateView;
Str(CurMarked, Temp);
TempB := CurMarked;
FOR I := 0 TO 7 DO
BEGIN
FileInfo.Name := Chr((TempB MOD 2)+48) + FileInfo.Name;
TempB := TempB DIV 2;
END;
FileInfo.Name[0] := #8;
IF Temp[0] = #1 THEN
Temp := '  '+Temp;
IF Temp[0] = #2 THEN
Temp := ' '+Temp;
TextBackGround(LightCyan);
TextColor(Black);
GotoXY(47, 22);
Write(Temp+'d'+' - '+FileInfo.Name+'b'+' - '+Byte2Hex(CurMarked)+'h');
IF Analyzed THEN
BEGIN
GotoXY(55, 19);
Write('              ');
GotoXY(55, 19);
Write(Frequenzy[CurMarked]);
END;
C := ReadKey;
IF C <> #0 THEN
BEGIN
IF NOT (C IN [#27, #13]) THEN
CurMarked := Ord(C);
END
ELSE
BEGIN
C := ReadKey;
IF NOT (C IN [#77, #75, #72, #80, #59]) THEN
CurMarked := Ord(C)
ELSE
CASE C OF
#75 : Dec(CurMarked);
#72 : Dec(CurMarked, 16);
#77 : Inc(CurMarked);
#80 : Inc(CurMarked, 16);
#59 :
IF NOT Analyzed THEN
AnalyzeFile;
END;
END;
UNTIL C IN [#27, #13];
TempB := CurMarked;
SetCursor(StartCursor);
ShowCursor;
RestoreScreen;
IF C = #13 THEN
BEGIN
C := Chr(TempB);
DoChar;
END;
END;
