{Alle Routinen fr die Funktionen auerhalb des Editors in HEXEDIT}

{$I OPEN.INC}
{$I SAVEAS.INC}
{$I BOOTSYS.INC}
{$I REPLACE.INC}
{$I ASCII.INC}

PROCEDURE DoUndo;

BEGIN
IF BackUp THEN
BEGIN
SaveScreen;
FoldOffWindow(' Note ',27, 9, 57, 14, LightCyan, Black+Blink, 1);
InfoBar(MSG5);
GotoXY(33, 11);
TextBackGround(LightCyan);
TextColor(Blue);
Write('Undo every change...');
GotoXY(32, 12);
TextColor(Black);
Write('Are you sure? [Y/N]: ');
BlockCursor;
REPEAT
C := ReadKey;
UNTIL C IN ['N', 'n', 'Y', 'y'];
IF C IN ['Y', 'y'] THEN
BEGIN
Close(WorkFile);
Erase(WorkFile);
ReName(BackUpFile, FileName);
RestoreScreen;
LoadFile;
UpDateView;
Insert := NOT Insert;
ChangeMode;
END
ELSE
RestoreScreen;
SetCursor(StartCursor);
ShowCursor;
END;
END;

PROCEDURE DoSave;

VAR
OldCurPos : WORD;
OldCursorPos : BYTE;
OldPosition : LONGINT;

BEGIN
GetFAttr(WorkFile, I);
IF I <> ReadOnly THEN
BEGIN
IF FileState = Changed THEN
BEGIN
IF UpDateCur THEN
BEGIN
HideCursor;
StatusBar('SAVING FILE...');
END;
OldCurPos := CurPos;
OldCursorPos := CursorPos;
OldPosition := Position;
IF MaxBlocks = 1 THEN
BEGIN
Seek(WorkFile, 0);
BlockWrite(WorkFile, FileArea, EndPos+1, Counts);
IF Counts <> (EndPos+1) THEN
BEGIN
SaveScreen;
FoldOffWindow(' Note ',21, 9, 63, 16, LightCyan, Black+Blink, 1);
TextBackground(LightCyan);
TextColor(LightRed);
GotoXY(26, 11);
Write('Cannot write file, disk''s full...');
IF (NOT BackUp) OR ((FileSize(WorkFile)-Counts) < Index) THEN BEGIN
InfoBar(MSG4);
TextBackground(LightCyan);
TextColor(Black);
GotoXY(26, 14);
Write('Press a key to exit...');
ReadKey;
EndUp('');
END
ELSE
BEGIN
InfoBar(MSG3);
TextBackground(LightCyan);
TextColor(Black);
GotoXY(23, 13);
Write('Continue without Backup/Undo Functions?');
GotoXY(39, 14);
Write('[Y/N]:');
BlockCursor;
REPEAT
C := ReadKey;
UNTIL C IN ['N', 'n', 'Y', 'y'];
IF C IN ['N', 'n'] THEN
EndUp('');
Erase(BackUpFile);
IF IOResult <> 0 THEN
EndUp('Error: Could not locate Backup-File...');
BackUp := FALSE;
Seek(WorkFile, FileSize(WorkFile));
BlockWrite(WorkFile, FileArea[Counts], EndPos+1-Counts, Counts);
RestoreScreen;
HideCursor;
END;
END;
IF FileSize(WorkFile) > EndPos+1 THEN
BEGIN
Seek(WorkFile, EndPos+1);
Truncate(WorkFile);
END;
END;
IF (Blocks > 0) AND (MaxBlocks > 1) THEN
BEGIN
CurPos := 0;
CursorPos := 0;
CheckUpperRange;
CurPos := 15104;
CursorPos := 255;
CheckLowerRange;
END;
IF (Blocks = 0) AND (MaxBlocks > 1) THEN
BEGIN
CurPos := 15104;
CursorPos := 255;
CheckLowerRange;
CurPos := 0;
CursorPos := 0;
Position := 1;
CheckUpperRange;
END;
Position := OldPosition;
CurPos := OldCurPos;
CursorPos := OldCursorPos;
FileState := UnChanged;
FileType := Old;
IF UpDateCur THEN
BEGIN
StatusBar('FILE SAVED...');
Delay(1500);
Reduce := NOT Reduce;
DoReduce;
END;
END;
END;
END;

PROCEDURE DoNewFile;

BEGIN
IF DoSaveAs THEN
BEGIN
HideCursor;
TempS := FileName;
DoOpen;
IF (FileType = New) AND (FileName = '') THEN
EndUp('');
IF FileName = '' THEN
BEGIN
FileName := TempS;
LoadFile;
END;
ShowCursor;
UpDateView;
Reduce := NOT Reduce;
DoReduce;
END;
END;

PROCEDURE CheckEnd;

BEGIN
IF DoSaveAs THEN
EndUp('');
END;

PROCEDURE DoHelp;

VAR
Index : BYTE;

PROCEDURE UpDateDisp;

VAR
I, J, K : BYTE;

BEGIN
K := Index+13;
IF K > High(Help) THEN
K := High(Help)+1;
FOR I := 8 TO 21 DO
BEGIN
GotoXY(10, I);
Write('                                                 ');
END;
FOR I := Index TO K DO
BEGIN
GotoXY(10, I+8-Index);
IF I <= High(Help) THEN
BEGIN
TextColor(Red);
FOR J := 1 TO 20 DO
Write(Help[I][J]);
TextColor(Blue);
FOR J := 21 TO Length(Help[I]) DO
Write(Help[I][J]);
END;
END;
END;

BEGIN
SaveScreen;
FoldOffWindow(' Help ', 8, 6, 62, 22, LightCyan, Yellow, 1);
StatusBar('WAITING...');
InfoBar(Help1);
HideCursor;
TextBackGround(LightCyan);
Index := 1;
UpDateDisp;
REPEAT
C := ReadKey;
IF C = #0 THEN
C := ReadKey;
IF C = #72 THEN
IF Index > 1 THEN
Dec(Index);
IF C = #80 THEN
IF Index < High(Help) THEN
Inc(Index);
IF C = #81 THEN
IF (Index+13) <= High(Help) THEN
Inc(Index, 13);
IF C = #73 THEN
IF Index > 13 THEN
Dec(Index, 13);
IF C = #71 THEN
Index := 1;
IF C = #79 THEN
Index := High(Help);
IF C IN[#79, #71, #73, #81, #72, #80] THEN
UpDateDisp;
UNTIL C IN [#27, #13];
SetCursor(StartCursor);
RestoreScreen;
END;

