{Der Print-File Dialog von CODESYS/HEXEDIT}

PROCEDURE DoPrint;

VAR
ToFile : BOOLEAN;

BEGIN
SaveScreen;
HideCursor;
ToFile := FALSE;
InfoBar(Printer3);
FoldOffWindow(' Print ', 29, 12, 51, 15, LightCyan, Yellow, 1);
REPEAT
GotoXY(30, 13);
TextColor(White);
TextBackGround(Blue);
IF ToFile THEN
BEGIN
TextColor(Black);
TextBackGround(LightCyan);
END;
Write(' 1) To local Printer ');
TextColor(Black);
TextBackGround(LightCyan);
IF ToFile THEN
BEGIN
TextColor(White);
TextBackGround(Blue);
END;
GotoXY(30, 14);
Write(' 2) To File          ');
C := ReadKey;
IF C = #0 THEN
C := ReadKey;
CASE C OF
#80, #72 : ToFile := NOT ToFile;
#49 : ToFile := FALSE;
#50 : ToFile := TRUE;
END;
UNTIL C IN [#27, #13];
RestoreScreen;
SaveScreen;
IF C = #13 THEN
IF ToFile THEN
BEGIN
TempS := FileName;
FOR X := 1 TO Length(TempS) DO
IF TempS[X] = '.' THEN
BREAK;
IF (X = Length(TempS)) AND (TempS[Length(TempS)] <> '.') THEN
TempS := TempS + '.PRN'
ELSE
BEGIN
TempS[X+1] := 'P';
TempS[X+2] := 'R';
TempS[X+3] := 'N';
END;
Assign(Txt, TempS);
ReSet(Txt);
IF IOResult <> 0 THEN
BEGIN
ReWrite(Txt);
PrintFile;
END
ELSE
BEGIN
Close(Txt);
StatusBar('WAITING...');
InfoBar(Printer4);
FoldOffWindow(' Info ', 23, 11, 55, 16, Red, Blue+Blink, 0);
GotoXY(25, 13);
TextBackGround(Red);
TextColor(White);
Write('Printfile exists already...');
GotoXY(25, 14);
Write('Recreate it or use it [R/U]:');
BlockCursor;
REPEAT
C := ReadKey;
UNTIL C IN ['R', 'r', 'U', 'u', #27];
HideCursor;
IF C <> #27 THEN
BEGIN
IF C IN ['R', 'r'] THEN
ReWrite(Txt)
ELSE
Append(Txt);
StatusBar('FILE READY...');
PrintFile;
END;
END;
END
ELSE
BEGIN
StatusBar('SEARCHING PRINTER...');
InfoBar(Printer1);
IF InitPrinter THEN
X := 14
ELSE
FOR X := 0 TO 14 DO
BEGIN
IF KeyPressed AND (ReadKey = #27) THEN
BREAK;
Str(15-X, TempS);
IF Length(TempS) = 1 THEN
BEGIN
TempS[0] := #2;
TempS[2] := TempS[1];
TempS[1] := ' ';
END;
StatusBar('SEARCHING PRINTER - '+TempS+' Times');
Delay(1000);
IF InitPrinter THEN
BEGIN
X := 14;
BREAK;
END;
END;
IF X <> 14 THEN
IF LPT <> 0 THEN
Close(Txt);
IF X = 14 THEN
IF LPT = 0 THEN
BEGIN
InfoBar(Printer2);
FoldOffWindow(' Info ', 20, 11, 60, 17, Red, Blue+Blink, 0);
HideCursor;
GotoXY(26, 13);
TextBackGround(Red);
TextColor(White);
Write('No local, ready Printer found!');
GotoXY(33, 15);
Write('Press any key... ');
ReadKey;
END
ELSE
BEGIN
Str(LPT, TempS);
TempS := 'PRINTER FOUND AT LPT ' + TempS + '...';
StatusBar(TempS);
PrintFile;
Close(Txt);
END;
END;
RestoreScreen;
SetCursor(StartCursor);
ShowCursor;
END;

PROCEDURE PrintFile;

VAR
Error, Comment, StartCur, EndCur, Info, HexD, FileD, StartPage : BOOLEAN;
Pos, Range : BYTE;
StartP, EndP : WORD;
ComString : STRING[60];
SL, EL, TL : LONGINT;

PROCEDURE CalcPosition;

BEGIN
IF Range = 0 THEN
BEGIN
SL := 0;
EL := FSize;
END;
IF Range = 1 THEN
BEGIN
SL := Blocks*15360;
EL := SL + 15360;
END;
IF Range = 2 THEN
BEGIN
SL := StartP*256;
EL := EndP*256;
END;
IF StartCur THEN
SL := Position;
IF EndCur THEN
EL := Position;
IF SL > EL THEN
BEGIN
TL := SL;
SL := EL;
EL := TL;
END;
IF EL > FSize THEN
EL := FSize;
END;

PROCEDURE Printer;

BEGIN
Error := FALSE;
RestoreScreen;
SaveScreen;
InfoBar(Printer7);
FoldOffWindow(' Info ', 20, 11, 50, 17, Blue, Yellow, 0);
TextBackGround(Blue);
TextColor(White);
GotoXY(23, 13);
IF LPT <> 0 THEN
Write('Preparing Printer...')
ELSE
Write(' Preparing File...');
IF Info THEN
BEGIN
WriteLn(Txt, ' HEXEDIT | Copyrights by Andy Mhling' + #10#13);
WriteLn(Txt, ' Filename: ' + FileName);
Str(FSize, TempS);
WriteLn(Txt, ' Filesize: ' + TempS + ' Bytes' + #10#13);
Str(SL, TempS);
IF Range <> 0 THEN
BEGIN
Write(Txt, ' Printing: Extract from Byte ' + TempS);
Str(EL, TempS);
WriteLn(Txt, ' to Byte ' + TempS + '...' + #10#13);
END
ELSE
WriteLn(Txt, ' Printing: Whole File...' + #10#13);
END;
IF Comment THEN
WriteLn(Txt, ' Comment : ' + ComString + #10#13);
Write('Done.');
TextColor(LightGreen);
GotoXY(25, 14);
Write('Printing File...');
IF (Pos <> 0) OR FileD OR HexD THEN
BEGIN
Write(Txt, #13#10);
IF Pos <> 0 THEN
TempS := ' Position   ';
IF HexD OR FileD THEN
TempS := TempS + '  ';
IF HexD THEN
TempS := TempS + 'Hexadecimal Dump                                ';
IF FileD AND HexD THEN
TempS := TempS + '  ';
IF FileD THEN
TempS := TempS + 'File Dump';
WriteLn(Txt, TempS + #10#13);
TempS := '             ';
IF Pos = 1 THEN
TempS := ' Hexadecimal';
IF Pos = 2 THEN
TempS := ' Decimal    ';
IF FileD OR HexD THEN
TempS := TempS + '  ';
IF HexD THEN
TempS := TempS + '00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F';
IF HexD AND FileD THEN
TempS := TempS + '   ';
IF FileD THEN
TempS := TempS + '0123456789ABCDEF';
WriteLn(Txt, TempS);
TempS := '';
IF Pos <> 0 THEN
TempS := ' -----------';
IF HexD THEN
TempS := TempS + '--------------------------------------------------';
IF FileD THEN
TempS := TempS + '------------------';
WriteLn(Txt, TempS);
TL := FilePos(WorkFile);
Seek(WorkFile, SL);
REPEAT
BlockRead(WorkFile, ComString[1], 16, I);
IF Pos <> 0 THEN
IF Pos <> 1 THEN
BEGIN
Str(SL, TempS);
FOR X := Length(TempS) TO 9 DO
TempS := '0' + TempS + #32;
END
ELSE
BEGIN
TempS := Long2Hex(SL, TRUE) + #32;
Delete(TempS, 1, 3);
TempS := '  ' + TempS;
END;
IF FileD OR HexD THEN
TempS := TempS + '| ';
IF HexD THEN
BEGIN
FOR X := 1 TO 16 DO
IF SL+X > EL THEN
BREAK
ELSE
TempS := TempS + Byte2Hex(Ord(ComString[X])) + #32;
IF X <> 16 THEN
FOR Y := X TO 16 DO
TempS := TempS + #32#32#32;
IF FileD THEN
TempS := TempS + '| ';
END;
IF FileD THEN
BEGIN
FOR X := 1 TO 16 DO
IF SL+X > EL THEN
BREAK
ELSE
IF Ord(ComString[X]) IN [0..31, 255] THEN
TempS := TempS + '.'
ELSE
TempS := TempS + ComString[X];
IF X <> 16 THEN
FOR Y := X TO 16 DO
TempS := TempS + #32;
END;
WriteLn(Txt, ' ' + TempS);
IF IOResult <> 0 THEN
BEGIN
IF LPT = 0 THEN
InfoBar(Printer8)
ELSE
InfoBar(Printer9);
FoldOffWindow(' Info ', 20, 11, 60, 17, Red, Blue+Blink, 0);
HideCursor;
GotoXY(26, 13);
TextBackGround(Red);
TextColor(White);
IF LPT = 0 THEN
Write(' Disk Full. Dumping aborted.')
ELSE
Write('  Printer Time-Out Error...');
GotoXY(33, 15);
Write('Press any key... ');
ReadKey;
Error := TRUE;
BREAK;
END;
IF KeyPressed AND (ReadKey = #27) THEN
BEGIN
FoldOffWindow(' Info ', 20, 11, 60, 17, Red, Blue+Blink, 0);
HideCursor;
GotoXY(26, 13);
TextBackGround(Red);
TextColor(White);
Write('    Printing aborted...    ');
GotoXY(33, 15);
Write('Press any key... ');
ReadKey;
Error := TRUE;
BREAK;
END;
Inc(SL, 16);
UNTIL SL >= EL;
Seek(WorkFile, TL);
END;
IF NOT Error THEN
BEGIN
Write('Done.');
GotoXY(26, 15);
TextColor(Yellow);
Write('Press any key...');
ReadKey;
END;
END;

BEGIN
FoldOffWindow(' Printer ', 7, 6, 73, 22, Cyan, Yellow, 1);
InfoBar(Printer5);
GotoXY(9, 8);
TextBackGround(LightCyan);
TextColor(Black);
Write('Co');
TextColor(Red);
Write('m');
TextColor(Black);
Write('ment:');
GotoXY(9, 9);
TextBackGround(Blue);
Write('                                                               ');
GotoXY(10, 11);
TextBackGround(LightCyan);
TextColor(Black);
Write('Prin');
TextColor(Red);
Write('t');
TextColor(Black);
Write(' Comment    [ ] ');
GotoXY(10, 13);
TextBackGround(LightCyan);
TextColor(Black);
Write('Print ');
TextColor(Red);
Write('I');
TextColor(Black);
Write('nfo Block [X] ');
GotoXY(10, 15);
Write('Print ');
TextColor(Red);
Write('H');
TextColor(Black);
Write('ex Dump     [X]');
GotoXY(10, 16);
Write('Print ');
TextColor(Red);
Write('F');
TextColor(Black);
Write('ile Dump    [X]');
GotoXY(10, 18);
Write('P');
TextColor(Red);
Write('r');
TextColor(Black);
Write('int Position Bar [X]');
GotoXY(11, 19);
Write('He');
TextColor(Red);
Write('x');
TextColor(Black);
Write('adecimal [X]');
GotoXY(11, 20);
Write('Decima');
TextColor(Red);
Write('l');
TextColor(Black);
Write('     [ ]');
GotoXY(42, 17);
TextBackGround(LightCyan);
TextColor(Black);
Write('Start at Cursor ');
TextColor(Red);
Write('P');
TextColor(Black);
Write('osition [ ]');
GotoXY(42, 18);
TextBackGround(LightCyan);
TextColor(Black);
Write('E');
TextColor(Red);
Write('n');
TextColor(Black);
Write('d at Cursor Position   [ ]');
GotoXY(40, 11);
Write('Range: ');
GotoXY(47, 11);
TextColor(Red);
Write('C');
TextColor(Black);
Write('omplete File     [X]');
GotoXY(47, 12);
TextColor(Red);
Write('O');
TextColor(Black);
Write('nly current Page [ ]');
GotoXY(47, 13);
TextColor(Red);
Write('D');
TextColor(Black);
Write('efine Pages      [ ]');
TextColor(DarkGray);
GotoXY(48, 14);
Write('[ ] Start:');
GotoXY(48, 15);
Write('[ ] End  :');
EndCur := FALSE;
StartCur := FALSE;
Info := TRUE;
Comment := FALSE;
Pos := 1;
HexD := TRUE;
FileD := TRUE;
StartPage := TRUE;
Range := 0;
EndP := 1;
StartP := 1;
ComString := '';
REPEAT
C := ReadKey;
CASE C OF
'I', 'i' : Info := NOT Info;
'T', 't' : Comment := NOT Comment;
'H', 'h' : HexD := NOT HexD;
'F', 'f' : FileD := NOT FileD;
'R', 'r' :
IF Pos <> 0 THEN
Pos := 0
ELSE
Pos := 1;
'X', 'x' : Pos := 1;
'L', 'l' : Pos := 2;
'P', 'p' :
BEGIN
StartCur := NOT StartCur;
IF StartCur THEN
EndCur := FALSE;
END;
'N', 'n' :
BEGIN
EndCur := NOT EndCur;
IF EndCur THEN
StartCur := FALSE;
END;
'C', 'c' : Range := 0;
'O', 'o' : Range := 1;
'D', 'd' : Range := 2;
'A', 'a' :
IF Range = 2 THEN
StartPage := TRUE;
'E', 'e' :
IF Range = 2 THEN
StartPage := FALSE;
'M', 'm' :
BEGIN
InfoBar(Printer6);
TextBackGround(Blue);
TextColor(Yellow);
SetCursor(StartCursor);
REPEAT
GotoXY(10, 9);
Write(ComString);
C := ReadKey;
REPEAT
IF C = #0 THEN
BEGIN
C := ReadKey;
C := ReadKey;
END;
UNTIL C <> #0;
IF C = #8 THEN
BEGIN
IF Length(ComString) > 0 THEN
BEGIN
Dec(ComString[0]);
GotoXY(WhereX-1, WhereY);
Write(' ');
END;
END
ELSE
IF (Length(ComString) < 60) AND NOT (C IN [#13, #27]) THEN
BEGIN
ComString := ComString + C;
END;
UNTIL C IN [#13, #27];
IF C = #13 THEN
Comment := TRUE
ELSE
BEGIN
ComString := '';
GotoXY(9, 9);
Write('                                                               ');
END;
InfoBar(Printer5);
TextBackGround(LightCyan);
HideCursor;
C := ' ';
END;
#0 :
BEGIN
C := ReadKey;
IF Range = 2 THEN
CASE C OF
#80 :
BEGIN
IF StartPage THEN
Dec(StartP)
ELSE
Dec(EndP);
IF (EndP > ((FSize DIV 256) + 1)) OR (EndP = 0) THEN
EndP := (FSize DIV 256) + 1;
IF (StartP > ((FSize DIV 256) + 1)) OR (StartP = 0) THEN
StartP := (FSize DIV 256) + 1;
END;
#72 :
BEGIN
IF StartPage THEN
Inc(StartP)
ELSE
Inc(EndP);
IF EndP > ((FSize DIV 256) + 1) THEN
EndP := 1;
IF StartP > ((FSize DIV 256) + 1) THEN
StartP := 1;
END;
END;
END;
END;
GotoXY(28, 13);
TextColor(Black);
CASE Info OF
TRUE : Write('X');
FALSE : Write(' ');
END;
GotoXY(28, 11);
TextColor(Black);
CASE Comment OF
TRUE : Write('X');
FALSE : Write(' ');
END;
GotoXY(30, 16);
TextColor(Black);
CASE FileD OF
TRUE : Write('X');
FALSE : Write(' ');
END;
GotoXY(30, 15);
TextColor(Black);
CASE HexD OF
TRUE : Write('X');
FALSE : Write(' ');
END;
GotoXY(30, 18);
TextColor(Black);
CASE Pos OF
0 : Write(' ')
ELSE
Write('X');
END;
TextColor(Black);
IF Pos = 0 THEN
TextColor(DarkGray);
GotoXY(11, 19);
Write('He');
IF Pos <> 0 THEN
TextColor(Red);
Write('x');
IF Pos <> 0 THEN
TextColor(Black);
Write('adecimal [ ]');
GotoXY(24, 19);
IF Pos = 1 THEN
Write('X');
GotoXY(11, 20);
Write('Decima');
IF Pos <> 0 THEN
TextColor(Red);
Write('l');
IF Pos <> 0 THEN
TextColor(Black);
Write('     [ ]');
GotoXY(24, 20);
IF Pos = 2 THEN
Write('X');
GotoXY(68, 17);
TextColor(Black);
CASE StartCur OF
TRUE : Write('X');
FALSE : Write(' ');
END;
GotoXY(68, 18);
TextColor(Black);
CASE EndCur OF
TRUE : Write('X');
FALSE : Write(' ');
END;
GotoXY(66, 11);
TextColor(Black);
IF Range = 0 THEN
Write('X')
ELSE
Write(' ');
GotoXY(66, 12);
TextColor(Black);
IF Range = 1 THEN
Write('X')
ELSE
Write(' ');
GotoXY(66, 13);
TextColor(Black);
IF Range = 2 THEN
Write('X')
ELSE
Write(' ');
TextColor(DarkGray);
IF Range = 2 THEN
TextColor(Black);
GotoXY(48, 14);
Write('[ ] St');
IF Range = 2 THEN
TextColor(Red);
Write('a');
IF Range = 2 THEN
TextColor(Black);
Write('rt:');
GotoXY(48, 15);
IF Range = 2 THEN
TextColor(Black);
Write('[ ] ');
IF Range = 2 THEN
TextColor(Red);
Write('E');
IF Range = 2 THEN
TextColor(Black);
Write('nd  :');
GotoXY(59, 14);
Write('      ');
GotoXY(59, 15);
Write('      ');
IF Range = 2 THEN
BEGIN
TextColor(Black);
GotoXY(49, 14);
IF StartPage THEN
Write('X')
ELSE
Write(' ');
GotoXY(49, 15);
IF StartPage THEN
Write(' ')
ELSE
Write('X');
GotoXY(59, 14);
Write(StartP);
GotoXY(59, 15);
Write(EndP);
END;
UNTIL C IN [#13, #27];
IF C = #13 THEN
BEGIN
CalcPosition;
Printer;
END;
END;
